<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="设备名称" prop="equipmentId">
        <!-- 可搜索设备名称，支持模糊查询 -->
        <el-select v-model="queryParams.equipmentId" placeholder="请选择对应设备" clearable style="width: 150px;" filterable>
          <el-option v-for="dict in equipmentOptions" :key="dict.equipmentId" :label="dict.equipmentName"
            :value="dict.equipmentId" />
        </el-select>
      </el-form-item>
      <el-form-item label="告警代码" prop="alarmCode">
        <el-input v-model="queryParams.alarmCode" placeholder="请输入告警代码" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="告警等级" prop="alarmLevel">
        <el-select v-model="queryParams.alarmLevel" placeholder="请选择告警等级" clearable style="width: 150px;">
          <el-option v-for="dict in alarm_level" :key="dict.value" :label="dict.label" :value="dict.value" />
        </el-select>
      </el-form-item>
      <el-form-item label="告警类型" prop="alarmType">
        <el-select v-model="queryParams.alarmType" placeholder="请选择告警类型" clearable style="width: 150px;">
          <el-option v-for="dict in alarm_type" :key="dict.value" :label="dict.label" :value="dict.value" />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <!-- <el-col :span="1.5">
        <el-button type="primary" plain icon="Plus" @click="handleAdd"
          v-hasPermi="['hnyz:alarmEvent:add']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="success" plain icon="Edit" :disabled="single" @click="handleUpdate"
          v-hasPermi="['hnyz:alarmEvent:edit']">修改</el-button>
      </el-col> -->
      <el-col :span="1.5">
        <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete"
          v-hasPermi="['hnyz:alarmEvent:remove']">删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="Download" @click="handleExport"
          v-hasPermi="['hnyz:alarmEvent:export']">导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="alarmEventList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <!-- <el-table-column label="主键，自增" align="center" prop="alarmId" /> -->
      <el-table-column label="设备id" align="center" prop="equipmentId" />
      <el-table-column label="告警代码" align="center" prop="alarmCode" />
      <el-table-column label="告警等级" align="center" prop="alarmLevel">
        <template #default="scope">
          <dict-tag :options="alarm_level" :value="scope.row.alarmLevel" />
        </template>
      </el-table-column>
      <el-table-column label="告警类型" align="center" prop="alarmType">
        <template #default="scope">
          <dict-tag :options="alarm_type" :value="scope.row.alarmType" />
        </template>
      </el-table-column>
      <el-table-column label="告警描述" align="center" prop="message" />
      <el-table-column label="当前值" align="center" prop="value" />
      <el-table-column label="单位" align="center" prop="unit">
        <template #default="scope">
          <dict-tag :options="unit_type" :value="scope.row.unit" />
        </template>
      </el-table-column>
      <el-table-column label="告警发生时间" align="center" prop="occurTime" width="180">
        <template #default="scope">
          <span>{{ parseTime(scope.row.occurTime, '{y}-{m}-{d} {h}:{i}:{s}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="告警恢复时间" align="center" prop="recoverTime" width="180">
        <template #default="scope">
          <span>{{ parseTime(scope.row.recoverTime, '{y}-{m}-{d} {h}:{i}:{s}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="告警状态" align="center" prop="status">
        <template #default="scope">
          {{ scope.row.status === '1' ? '已恢复' : '未恢复' }}
        </template>
      </el-table-column>

      <el-table-column label="备注" align="center" prop="remark" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template #default="scope">
          <!-- <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)"
            v-hasPermi="['hnyz:alarmEvent:edit']">修改</el-button> -->
          <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)"
            v-hasPermi="['hnyz:alarmEvent:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum"
      v-model:limit="queryParams.pageSize" @pagination="getList" />

    <!-- 添加或修改告警中心管理对话框 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form ref="alarmEventRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="设备名称" prop="equipmentId">
          <!-- 可搜索设备名称，支持模糊查询 -->
          <el-select v-model="form.equipmentId" placeholder="请选择对应设备" clearable filterable>
            <el-option v-for="dict in equipmentOptions" :key="dict.equipmentId" :label="dict.equipmentName"
              :value="dict.equipmentId" />
          </el-select>
        </el-form-item>
        <el-form-item label="告警代码" prop="alarmCode">
          <el-input v-model="form.alarmCode" placeholder="请输入告警代码" />
        </el-form-item>
        <el-form-item label="告警等级" prop="alarmLevel">
          <el-select v-model="form.alarmLevel" placeholder="请选择告警等级">
            <el-option v-for="dict in alarm_level" :key="dict.value" :label="dict.label"
              :value="parseInt(dict.value)"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="告警类型" prop="alarmType">
          <el-select v-model="form.alarmType" placeholder="请选择告警类型">
            <el-option v-for="dict in alarm_type" :key="dict.value" :label="dict.label" :value="dict.value"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="告警描述" prop="message">
          <el-input v-model="form.message" placeholder="请输入告警描述" />
        </el-form-item>
        <el-form-item label="当前值" prop="value">
          <el-input v-model="form.value" placeholder="请输入当前值" />
        </el-form-item>
        <el-form-item label="单位" prop="unit">
          <el-select v-model="form.unit" placeholder="请选择单位">
            <el-option v-for="dict in unit_type" :key="dict.value" :label="dict.label" :value="dict.value"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="告警发生时间" prop="occurTime">
          <el-date-picker clearable v-model="form.occurTime" type="date" value-format="YYYY-MM-DD"
            placeholder="请选择告警发生时间">
          </el-date-picker>
        </el-form-item>
        <el-form-item label="告警恢复时间" prop="recoverTime">
          <el-date-picker clearable v-model="form.recoverTime" type="date" value-format="YYYY-MM-DD"
            placeholder="请选择告警恢复时间">
          </el-date-picker>
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" placeholder="请输入备注" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="AlarmEvent">
import { listAlarmEvent, getAlarmEvent, delAlarmEvent, addAlarmEvent, updateAlarmEvent } from "@/api/hnyz/alarmEvent";
import { getEquipmentList } from "@/api/hnyz/equipment";
import { onMounted } from "vue";

onMounted(() => {
  getEquipmentOptions();
});

const equipmentOptions = ref([]);
function getEquipmentOptions() {
  getEquipmentList().then(response => {
    equipmentOptions.value = response.data;
  });
}
const { proxy } = getCurrentInstance();
const { alarm_level, alarm_type, unit_type } = proxy.useDict('alarm_level', 'alarm_type', 'unit_type');

const alarmEventList = ref([]);
const open = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const title = ref("");

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    equipmentId: null,
    alarmCode: null,
    alarmLevel: null,
    alarmType: null,
    message: null,
    value: null,
    unit: null,
    occurTime: null,
    recoverTime: null,
    status: null,
  },
  rules: {
  }
});

const { queryParams, form, rules } = toRefs(data);

/** 查询告警中心管理列表 */
function getList() {
  loading.value = true;
  listAlarmEvent(queryParams.value).then(response => {
    alarmEventList.value = response.rows;
    total.value = response.total;
    loading.value = false;
  });
}

// 取消按钮
function cancel() {
  open.value = false;
  reset();
}

// 表单重置
function reset() {
  form.value = {
    alarmId: null,
    equipmentId: null,
    alarmCode: null,
    alarmLevel: null,
    alarmType: null,
    message: null,
    value: null,
    unit: null,
    occurTime: null,
    recoverTime: null,
    status: "0",
    createTime: null,
    createBy: null,
    updateBy: null,
    updateTime: null,
    remark: null
  };
  proxy.resetForm("alarmEventRef");
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef");
  handleQuery();
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.alarmId);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
}

/** 新增按钮操作 */
function handleAdd() {
  reset();
  open.value = true;
  title.value = "添加告警中心管理";
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset();
  const _alarmId = row.alarmId || ids.value
  getAlarmEvent(_alarmId).then(response => {
    form.value = response.data;
    open.value = true;
    title.value = "修改告警中心管理";
  });
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["alarmEventRef"].validate(valid => {
    if (valid) {
      if (form.value.alarmId != null) {
        updateAlarmEvent(form.value).then(response => {
          proxy.$modal.msgSuccess("修改成功");
          open.value = false;
          getList();
        });
      } else {
        addAlarmEvent(form.value).then(response => {
          proxy.$modal.msgSuccess("新增成功");
          open.value = false;
          getList();
        });
      }
    }
  });
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _alarmIds = row.alarmId || ids.value;
  proxy.$modal.confirm('是否确认删除告警中心管理编号为"' + _alarmIds + '"的数据项？').then(function () {
    return delAlarmEvent(_alarmIds);
  }).then(() => {
    getList();
    proxy.$modal.msgSuccess("删除成功");
  }).catch(() => { });
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download('hnyz/alarmEvent/export', {
    ...queryParams.value
  }, `alarmEvent_${new Date().getTime()}.xlsx`)
}

getList();
</script>
